## Is it there ?

It's a D program that generates perfect hash sets for constant dictionaries made of strings.

It's based on the fact that for any small set of unique words there's a probability that exists a hash function able to produce different results for each element.
IsItThere finds, using brute force and a PRNG, the coefficients that produce the same results as this hypothetical function.
These coefficients are then used to generate the source code of the hash set.

The hash set produced is faster than any equivalent build at runtime:
- the coefficients are stored on the stack (vs on the heap for a standard hash set).
- the hash function simply adds the coefficients, mapped by each input byte of an entry (vs often several bit operations for a standard hash set).
- "perfect" means no collision, so there's a single string comparison for each bucket that's not empty (vs possibly more than one for a standard hash set).

## Build

[DUB](https://code.dlang.org/download) is required:

`dub build --build=release`

## Usage

```
--cc : case care, by default true.
--fk : the kind of the formater used to write the results.
--fn : the name of the class produced by the formater.
--if : the file that contains the words, one by line.
--is : the initial seed, optional, 0 means unpredictable.
--ml : the length of the map, optional.
--nt : the count of threads used, optional.
--of : the name of the output file, optional, when not set stdout is used.
--pf : the period factor, optional. Multiply by 1<<32 to get the actuall period.
```

The dictionary length should not be over `(0xFFFF / 2)` words.
This program is designed for small dictionaries such as the keyword list of a programing language or to get efficient equivalents of certain usages of `switch` (or `case of`...).

Notes:
- A compact dictionary is not always faster since it can lead to more comparisons.
- It's often interesting to choose a map length that's a power of two in order to avoid an integer division after the hashing. The formaters write a standard modulo but since the set size is constant it's very likely to be optimized by any compiler.
- After generating d code, pass it to dfmt ! Constant arrays are written on very long lines.

## Output

The programs formats the results either in a file or in `stdout`. The formatting relies on the `fk` parameters.

#### D

The input encoding is expected to be UTF8.
The result of the D formater is ready to be used.

#### Pascal

The input encoding is expected to be UTF8.
The result of the Pascal formater needs edition:
- the right content must be put in the `interface` and the `implementation` sections.
- the switch `{$MODESWITCH ADVANCEDRECORDS}` that's written before the `record` must be cut and paste between the `unit` declaration and the `interface` beginning

## Examples

#### buildable

- `cd` to the repository root.
- `bin/isitthere --if=test/d2kw.txt --of="test/d2kw.d" --ml=512 --fk=d --fn=DlangKeywords --is=2`.
- open the new `test/d2kw.d` file.
- adds this code:

```d
unittest
{
    assert( "qsdfsf" !in DlangKeywords);
    assert( "static" in DlangKeywords);
}
```

- save and test the file: `dmd d2kw.d -unittest -main`.

#### in D

The Toy programming language STYX uses a [hash map](https://github.com/Basile-z/styx/blob/e4bca01e1218293ab0cd845865a4fa931204fd0f/src/yatol/lexer/types.d#L185) generated by the program in order to [filter the keywords](https://github.com/Basile-z/styx/blob/e4bca01e1218293ab0cd845865a4fa931204fd0f/src/yatol/lexer/types.d#L383) when identifiers are created.

#### in Pascal

The D IDE dexed uses [two hash sets](https://github.com/Basile-z/dexed/blob/master/src/ce_dlangmaps.pas) produced by this program.

## Other information

- licensed under the Boost Software license, 1.0
